

#include <cdefBF561.h>


// This variable is accessible by both Cores
__attribute__((section(".l2data")))
static volatile int g_lock = 2;

void do_blink(void)
{
	int i;


	*pFIO2_DIR    = 0xffff;
	*pFIO2_FLAG_D = 0x00ff;

	delay();
	delay();
	delay();
	delay();

	for (i = 0; i < 8; i++) {
		g_lock = 1;   // Do not allow Core B to toggle leds
		*pFIO2_FLAG_D = 0x0000;
		delay();
		*pFIO2_FLAG_D = 0x00ff;
		delay();
		g_lock = 0;   // Allow Core B to toggle leds
		delay();
	}
	g_lock = 2;
}

// Now this is the blink control of core B
__attribute__((section(".l1data_a.b")))
static int g_flag = 0;

__attribute__((section(".l1code.b")))

int coreB_delay()
{
	int i;
	for (i = 0; i < 4000000; i++) {
		asm ("nop;");
	}
}


__attribute__((section(".l1code.b")))
void coreB_blink()
{
	while (g_lock < 2) {
		// We are only allowed to change LEDs in our 'time slice', see
		// above.
		if (g_lock == 0) {
			*pFIO2_FLAG_D = 0xff00;
			g_lock = 1; // lock ourselves out
		}
	}
	*pFIO2_FLAG_D = 0xaa00;

}


__attribute__((section(".l1code.b")))
void coreB_blink2()
{
	unsigned short x = 1;

	while (1) {
		coreB_delay();
		*pFIO2_FLAG_D = x;
		asm("BP2:");
		// x = (x << 1) | (x >> 15);
		x = (x >> 1) | (x << 15);
	}
		
}

__attribute__((section(".l1code.b")))
void coreB_main()
{
	unsigned short val;

	val = *pFIO2_DIR;
	val |= 0xffff;
	*pFIO2_DIR = val;

	coreB_blink();
	while (0) {
		asm("idle;");
	}
	coreB_blink2();
}



