/*
 *
 * Little stupid blink program
 *
 * 2004, 2005 Martin Strubel <hackfin@section5.ch>
 *
 * This serves as a basic example to get up and going with
 * the GNU toolchain.
 *
 * Supported boards: see Makefile
 *
 * $Id: main.c 660 2008-08-09 16:08:43Z strubi $
 *
 */

#if defined (BOARD_EZKIT_BF533) || defined (BOARD_STAMP_BF533) || \
	defined (BOARD_MIT_MULTIBF533)
#include <cdefBF533.h>
#elif defined (BOARD_EZKIT_BF537) || defined (BOARD_CM_BF537)
#include <cdefBF537.h>
#elif defined (BOARD_EZKIT_BF561)
#include <cdefBF561.h>
#endif


// These are in stamp.asm

extern void delay();
extern void blink();

#if defined(BOARD_EZKIT_BF533)

#define pFlashA_PortB_Dir	(volatile unsigned char *) 0x20270007
#define pFlashA_PortB_Data	(volatile unsigned char *) 0x20270005

void do_blink(void)
{
	int i;

	// Initialize EBIU async memory banks
	*pEBIU_AMBCTL0	= 0x7bb07bb0;
	*pEBIU_AMBCTL1	= 0x7bb07bb0;
	*pEBIU_AMGCTL	= 0x000f;
	// init flash a port b direction
	*pFlashA_PortB_Dir = 0x3f;

	i = 0;
	int leds = 0x15;
	while (i < 40) {
		*pFlashA_PortB_Data = leds;
		delay();
		leds ^= 0xff;
		i++;
	}
}

#elif defined(BOARD_EZKIT_BF537) || defined (BOARD_CM_BF537)

void do_blink(void)
{
	int i;

	*pPORTG_FER = 0;
	*pPORTGIO_DIR           = 0x0FC0;               // LEDs
	*pPORTGIO_SET           = 0x55 << 6;
	*pPORTGIO_CLEAR         = 0xaa << 6;

	i = 0;
	while (i < 10) {
		*pPORTGIO_TOGGLE = 0x0fc0;
		asm("BP2:\n");
		delay();
		i++;
	}
}

#elif defined(BOARD_EZKIT_BF561)

// See bf561_singleblink.c

#elif defined(BOARD_STAMP_BF533)

void do_blink(void)
{
	int i;

	*pFIO_DIR    = 0x001c;
	*pFIO_FLAG_D = 0x0008;
	*pFIO_INEN   = 0x0160; // enable input for buttons

	i = 0;
	while (i < 10) {
		*pFIO_FLAG_T = 0x001c;
		delay();
		i++;
	}
}

#elif defined(BOARD_MIT_MULTIBF533)

void do_blink(void)
{
	int i;

	*pFIO_DIR    = 0x0100;
	*pFIO_FLAG_D = 0x0100;
	*pFIO_INEN   = 0x0000; // enable input for buttons

	i = 0;
	while (i < 10000) {
		*pFIO_FLAG_T = 0x0100;
		delay();
		i++;
	}
}

#endif



short g_state = 0;

int main()
{

#if defined(BOARD_EZKIT_BF561)
	*pSICA_SYSCR &= ~0x20; // Start Core B
	asm ("ssync;");
#endif

#ifdef BLINK_AND_CRASH
	blink();
#endif

#ifdef BLINK_AND_WAIT
	do_blink();
#endif

#ifdef PFTEST
	pfiosetup((unsigned char *) 0x0000000, (unsigned char *) 0x00010000);
	irqsetup();
#endif

	asm("main_end:");
	asm("nop;");
	asm("idle;");
	asm("jump main_end;");
}



